[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.26 and 1.74

version 1.26, 2021/11/12 02:38:05 version 1.74, 2021/12/11 20:57:51
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset
         # no bsort for now  
         sed -n "$1" /var/run/dmesg.boot  
 }  
   
 # Fake up some things from install.sub that we don't need to actually do  CFILE=SHA256.sig
 prefetcharea_fs_list() {  DESTDIR=${DESTDIR:-}
         echo "/mnt/tmp"  FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
 }  
 reset_watchdog() {  
 }  
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
 # Create a temporary directory based on the supplied directory name prefix.  HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   LOCALSRC=
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do          # If we're not in the installer,
                 ((++_i < 10000)) || return 1          # we have mktemp and a more hostile environment
         done          if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
         echo "$_dir"          echo "$_dir"
 }  }
   
 # Run a command ($2+) as unprivileged user ($1).  fetch() {
 # Take extra care that after "cmd" no "user" processes exist.          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit
 #  
 # Optionally:  
 #       - create "file" and chown it to "user"  
 #       - after "cmd", chown "file" back to root  
 #  
 # Usage: do_as user [-f file] cmd  
 do_as() {  
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1          # If we're not in the installer, we have su(1)
         shift          # and doas(1) is unlikely to be configured.
           if [ -x /usr/bin/su ]; then
                   /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
                   _exit="$?"
           else
                   /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
                   _exit="$?"
           fi
   
         if [[ $1 == -f ]]; then          if [ "$_exit" -ne 0 ]; then
                 _file=$2                  rm -f "$_dst"
                 shift 2                  echo "Cannot fetch $_src" >&2
                   return 1
         fi          fi
   }
   
         if [[ -n $_file ]]; then  verify() {
                 >$_file          # On the installer we don't get sha256 -C, so fake it.
                 chown "$_user" "$_file"          if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
         fi          fi
   }
   
         doas -u "$_user" "$@"  devices_needing_firmware() {
         _rc=$?          local _d _m _grep _dmesgtail _last=''
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do          # When we're not in the installer, the dmesg.boot can
                 echo "Processes still running for user $_user after: $@"          # contain multiple boots, so only look in the last one
                 sleep 1          _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )
         done  
   
         [[ -n $_file ]] && chown root "$_file"          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   _grep="grep"
                   [ "$_last" = "$_d" ] && continue
                   [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "
                   [ "$_m" = "${_m#^}" ] && _grep="fgrep"
   
         return $_rc                  echo "$_dmesgtail" | $_grep -q "$_m" || continue
                   echo "$_d"
                   _last="$_d"
           done
 }  }
   
 unpriv() {  firmware_filename() {
         do_as _sndio "$@"          local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
 unpriv2() {  firmware_devicename() {
         do_as _file "$@"          local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
 }  }
   
 # "fail" needs to be replaced with the "ask_yn" loop like in the installer.  installed_firmware() {
 _issue=          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
 fail() {                  [ -e "$fw" ] || continue
         echo $_issue >&2                  echo "${fw##*/}"
         exit 1          done
 }  }
   
 VNAME=$(sysctl -n kern.osrelease)  add_firmware () {
 VERSION="${VNAME%.*}${VNAME#*.}"          local _f="${1##*/}"
 FWDIR="$VNAME"          local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
           ftp -D "Install" -Vmo- "file:${1}" |
                   tar -s ",^\+,${_pkgdir}/+," \
                       -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
 # TODO: We need the firmware for the system we just installed          # TODO: Should we mark these so real fw_update can -Drepair?
 #       not the one we booted from.  For example:          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release  /^@comment pkgpath/ -1a
 #         will install the firmware from the 7.0 directory instead of  @option manual-installation
 #         from the snapshots dir.  @option firmware
 #       If they're using sysupgrade, then the installer kernel will be correct.  @comment install-script
 #       If we're doing this in the installer we can check what they picked  .
 #       for downloading sets and use that value.  w
 #       Otherwise, the fw_update after first boot will fix it up for us.  EOL
   }
   
 HTTP_FWDIR=$FWDIR  delete_firmware() {
 set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots  
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}          # TODO: Check hash for files before deleting
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub          echo "Uninstalling $_pkg"
 FWPATTERNS="file:${0%/*}/firmware_patterns"          _cwd="${_pkgdir}/$_pkg"
   
 # TODO: support srclocal installation of firmware somehow          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
 fw_update() {  
         local _src=$1 _tmpfs_list _tmpfs _tmpsrc \  
                 _t=Get _cfile="/tmp/SHA256" _pkgdir=/mnt/var/db/pkg \  
                 _f _r _remove _i _installed  
         local _srclocal=false _unpriv=unpriv  
   
         echo "Let's $MODE firmware!"          while read -r c g; do
         local _d _drivers=$(                  case $c in
                 last=''                  @cwd) _cwd="${DESTDIR}$g"
                 $_unpriv ftp -D "Detecting" -Vmo- $FWPATTERNS |                    ;;
                 while read _d _m; do                  @*) continue
                         grep=grep                    ;;
                         [ "$last" = "$_d" ] && continue                  *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                         [ "$_m" ] || _m="^$_d[0-9][0-9]* at "                    ;;
                         [ "$_m" = "${_m#^}" ] && grep=fgrep                  esac
                         $grep -q "$_m" /var/run/dmesg.boot || continue          done < "${_pkgdir}/${_pkg}/+CONTENTS"
                         echo $_d  
                         last=$_d  
                 done  
         )  
   
         if [ -z "$_drivers" ]; then          # We specifically rm -f here because not removing files/dirs
                 echo "No devices found which need firmware files to be downloaded."          # is probably not worth failing over.
                 return          for _r in "${_remove[@]}" ; do
         fi                  if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
         ! _tmpfs_list=$(prefetcharea_fs_list) &&                          # without rmdir on the install media.
                 echo "Cannot determine prefetch area" >&2 && return                          [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                   else
         for _tmpfs in $_tmpfs_list; do                          rm -f "$_r"
                 # Try to clean up from previous runs, assuming  
                 # the _tmpfs selection yields the same mount  
                 # point.  
                 for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do  
                         [[ -d $_tmpsrc ]] && rm -r $_tmpsrc  
                 done  
   
                 # Create a download directory for the firmware and  
                 # check that the _sndio user can read files from  
                 # it. Otherwise cleanup and skip the filesystem.  
                 if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then  
                         (  
                         >$_tmpsrc/t &&  
                         $_unpriv cat $_tmpsrc/t  
                         ) >/dev/null 2>&1 && break ||  
                                 rm -r $_tmpsrc  
                 fi                  fi
         done          done
   }
   
         [[ ! -d $_tmpsrc ]] &&  usage() {
                 echo "Cannot create prefetch area" >&2 && return 1          echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"
           exit 2
   }
   
         # Cleanup from previous runs.  INSTALL=true
         rm -f $_cfile $_cfile.sig  DOWNLOAD=true
   
         _t=Get/Verify  while getopts dL name
   do
          case "$name" in
          # "download only" means local dir and don't install
          d) LOCALSRC=. INSTALL=false ;;
          L) LOCALSRC=. ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
         ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&  # If we're installing from a local dir
             echo "Cannot fetch SHA256.sig" >&2 && return 1  # we don't want to download anything
   [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false
   [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
   
         # Verify signature file with public keys.  set -A devices -- "$@"
         ! $_unpriv -f "$_cfile" \  
             signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&  
             echo "Signature check of SHA256.sig failed" >&2 && return 1  
   
         for _d in $_drivers; do  [ "${devices[*]:-}" ] ||
                 $UU && reset_watchdog      set -A devices -- $( devices_needing_firmware )
                 _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )  
                 _installed=$(  
                 for fw in "${_pkgdir}/$_d-firmware"*; do  
                         [ -e "$fw" ] || continue  
                         echo ${fw##*/}  
                 done  
                 )  
   
                 for _i in $_installed; do  if [ ! "${devices[*]:-}" ]; then
                         if [ "$_f" = "$_i.tgz" ]; then          echo "No devices found which need firmware files to be downloaded."
                                 echo "$_i already installed"          exit
                                 continue 2  fi
                         fi  
                 done  
   
                 rm -f /tmp/h /tmp/fail  if "$DOWNLOAD"; then
           fetch "$CFILE"
           ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
               echo "Signature check of SHA256.sig failed" >&2 && exit 1
   fi
   
                 # Fetch firmware file and create a checksum by piping through  for f in "${devices[@]}"; do
                 # sha256. Create a flag file in case ftp failed. Firmware          d="$( firmware_devicename "$f" )"
                 # from net is written to the prefetch area.  
                 ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |  
                 ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||  
                     unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )  
   
                 # Handle failed transfer.          if [ "$f" = "$d" ]; then
                 if [[ -f /tmp/fail ]]; then                  f=$( firmware_filename "$d" || true )
                         rm -f "$_tmpsrc/$_f"                  [ "$f" ] || continue
                         echo "Fetching of $_f failed!" >&2                  f="$LOCALSRC/$f"
                         continue          elif ! "$INSTALL" && ! grep -q "($f)" "$CFILE" ; then
                 fi                  echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
                 # Verify firmware by comparing its checksum with SHA256.          set -A installed -- $( installed_firmware "$d" )
                 if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then  
                         [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"  
                         echo "Checksum test for $_f failed." >&2  
                         continue  
                 fi  
   
                 # TODO: Check hash for files before deleting          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                 if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then                  for i in "${installed[@]}"; do
                         echo "Uninstalling $_installed"                          if [ "${f##*/}" = "$i.tgz" ]; then
                         cwd=${_pkgdir}/$_installed                                  echo "$i already installed"
                                   continue 2
                           fi
                   done
           fi
   
                         set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"          if [ -e "$f" ]; then
                   if "$DOWNLOAD"; then
                         while read c g; do                          echo "Verify existing ${f##*/}"
                                 case $c in                          verify "$f" || continue
                                 @cwd) cwd="/mnt/$g"                  # else assume it was verified when downloaded
                                   ;;  
                                 @*) continue  
                                   ;;  
                                 *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"  
                                   ;;  
                                 esac  
                         done < "${_pkgdir}/$_installed/+CONTENTS"  
   
                         # We specifically rm -f here because not removing files/dirs  
                         # is probably not worth failing over.  
                         for _r in "${_remove[@]}" ; do  
                                 if [ -d "$_r" ]; then  
                                         # Try hard not to actually remove recursively  
                                         # without rmdir on the install media.  
                                         [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"  
                                 else  
                                         rm -f "$_r"  
                                 fi  
                         done  
                 fi                  fi
           elif "$INSTALL" && ! "$DOWNLOAD"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
           else
                   fetch  "$f" || continue
                   verify "$f" || continue
           fi
   
                 # TODO: Should we mark these so real fw_update can -Drepair?          "$INSTALL" || continue
                 ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |  
                         tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \  
                         -s ",^firmware,mnt/etc/firmware," \  
                         -C / -zxphf - "+*" "firmware/*"  
   
                 ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          if [ "${installed[*]:-}" ]; then
 /^@comment pkgpath/ -1a                  for i in "${installed[@]}"; do
 @option manual-installation                          delete_firmware "$i"
 @option firmware                  done
 @comment install-script          fi
 .  
 w  
 EOL  
         done  
 }  
   
 fw_update "$FWURL"          add_firmware "$f"
   done
   

Legend:
Removed from v.1.26  
changed lines
  Added in v.1.74

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>